package service

import (
	"reflect"

	cda "git.loafle.net/commons/di-go/annotation"
	cdr "git.loafle.net/commons/di-go/registry"
	_ "git.loafle.net/overflow/commons-go/core/annotation"
)

var AuthServiceType = reflect.TypeOf((*AuthService)(nil))

func init() {
	cdr.RegisterType(AuthServiceType)
}

type AuthService struct {
	cda.TypeAnnotation `annotation:"@overflow:RPCService()"`

	AcceptedChan chan<- string
	DeniedChan   chan<- struct{}
}

func (as *AuthService) Accept(probeKey string) error {
	as.AcceptedChan <- probeKey
	return nil
}

func (as *AuthService) Deny() error {
	as.DeniedChan <- struct{}{}
	return nil
}
